diff --git a/src/backend/storage/buffer/freelist.c b/src/backend/storage/buffer/freelist.c
index 6fc5efa..cd75f3b 100644
--- a/src/backend/storage/buffer/freelist.c
+++ b/src/backend/storage/buffer/freelist.c
@@ -3,6 +3,11 @@
  * freelist.c
  *	  routines for manipulating the buffer pool's replacement strategy.
  *
+ * The name "freelist.c" is now a bit of a misnomer, since this module
+ * controls not only the list of free buffers per se, but the entire
+ * mechanism for looking up existing shared buffers and the strategy
+ * for choosing replacement victims when needed.
+ *
  * Note: all routines in this file assume that the BufMgrLock is held
  * by the caller, so no synchronization is needed.
  *
@@ -25,6 +30,52 @@
 #include "storage/bufmgr.h"
 
 
+/*
+ * Definitions for the buffer replacement strategy
+ */
+#define STRAT_LIST_UNUSED	(-1)
+#define STRAT_LIST_B1		0	/* A1out */
+#define STRAT_LIST_T1		1	/* A1 */
+#define STRAT_LIST_T2		2	/* Am */
+#define STRAT_NUM_LISTS		3
+
+/*
+ * We have a cache directory block (CDB) for every file page currently being
+ * tracked by the strategy module.  There can be more CDBs than there are
+ * actual shared buffers, allowing pages no longer in cache to still be
+ * tracked.
+ */
+typedef struct
+{
+	int			prev;			/* list links */
+	int			next;
+	short		list;			/* ID of list it is currently in */
+	bool		t1_vacuum;		/* t => present only because of VACUUM */
+	TransactionId t1_xid;		/* the xid this entry went onto T1 */
+	BufferTag	buf_tag;		/* page identifier */
+	int			buf_id;			/* currently assigned data buffer, or -1 */
+} BufferStrategyCDB;
+
+/*
+ * The shared strategy control information.
+ */
+typedef struct
+{
+	int			target_T1_size; /* What T1 size are we aiming for */
+	int			listUnusedCDB;	/* All unused StrategyCDB */
+	int			listHead[STRAT_NUM_LISTS];		/* CDB lists */
+	int			listTail[STRAT_NUM_LISTS];
+	int			listSize[STRAT_NUM_LISTS];
+	Buffer		listFreeBuffers;	/* List of unused buffers */
+
+	long		num_lookup;		/* Some hit statistics */
+	long		num_hit[STRAT_NUM_LISTS];
+	time_t		stat_report;
+
+	/* Array of CDB's starts here */
+	BufferStrategyCDB cdb[1];	/* VARIABLE SIZE ARRAY */
+} BufferStrategyControl;
+
 /* GUC variable: time in seconds between statistics reports */
 int			DebugSharedBuffers = 0;
 
@@ -41,7 +92,6 @@ static TransactionId strategy_vacuum_xid;
 #define B1_LENGTH	(StrategyControl->listSize[STRAT_LIST_B1])
 #define T1_LENGTH	(StrategyControl->listSize[STRAT_LIST_T1])
 #define T2_LENGTH	(StrategyControl->listSize[STRAT_LIST_T2])
-#define B2_LENGTH	(StrategyControl->listSize[STRAT_LIST_B2])
 
 
 /*
@@ -128,8 +178,7 @@ StrategyStatsDump(void)
 		long		all_hit,
 					b1_hit,
 					t1_hit,
-					t2_hit,
-					b2_hit;
+					t2_hit;
 		int			id,
 					t1_clean,
 					t2_clean;
@@ -155,7 +204,7 @@ StrategyStatsDump(void)
 		}
 
 		if (StrategyControl->num_lookup == 0)
-			all_hit = b1_hit = t1_hit = t2_hit = b2_hit = 0;
+			all_hit = b1_hit = t1_hit = t2_hit = 0;
 		else
 		{
 			b1_hit = (StrategyControl->num_hit[STRAT_LIST_B1] * 100 /
@@ -164,18 +213,16 @@ StrategyStatsDump(void)
 					  StrategyControl->num_lookup);
 			t2_hit = (StrategyControl->num_hit[STRAT_LIST_T2] * 100 /
 					  StrategyControl->num_lookup);
-			b2_hit = (StrategyControl->num_hit[STRAT_LIST_B2] * 100 /
-					  StrategyControl->num_lookup);
-			all_hit = b1_hit + t1_hit + t2_hit + b2_hit;
+			all_hit = b1_hit + t1_hit + t2_hit;
 		}
 
 		errcxtold = error_context_stack;
 		error_context_stack = NULL;
-		elog(DEBUG1, "ARC T1target=%5d B1len=%5d T1len=%5d T2len=%5d B2len=%5d",
-			 T1_TARGET, B1_LENGTH, T1_LENGTH, T2_LENGTH, B2_LENGTH);
-		elog(DEBUG1, "ARC total   =%4ld%% B1hit=%4ld%% T1hit=%4ld%% T2hit=%4ld%% B2hit=%4ld%%",
-			 all_hit, b1_hit, t1_hit, t2_hit, b2_hit);
-		elog(DEBUG1, "ARC clean buffers at LRU       T1=   %5d T2=   %5d",
+		elog(DEBUG1, "2Q T1target=%5d B1len=%5d T1len=%5d T2len=%5d",
+			 T1_TARGET, B1_LENGTH, T1_LENGTH, T2_LENGTH);
+		elog(DEBUG1, "2Q total   =%4ld%% B1hit=%4ld%% T1hit=%4ld%% T2hit=%4ld%%",
+			 all_hit, b1_hit, t1_hit, t2_hit);
+		elog(DEBUG1, "2Q clean buffers at LRU       T1=   %5d T2=   %5d",
 			 t1_clean, t2_clean);
 		error_context_stack = errcxtold;
 
@@ -183,7 +230,6 @@ StrategyStatsDump(void)
 		StrategyControl->num_hit[STRAT_LIST_B1] = 0;
 		StrategyControl->num_hit[STRAT_LIST_T1] = 0;
 		StrategyControl->num_hit[STRAT_LIST_T2] = 0;
-		StrategyControl->num_hit[STRAT_LIST_B2] = 0;
 		StrategyControl->stat_report = now;
 	}
 }
@@ -192,7 +238,7 @@ StrategyStatsDump(void)
  * StrategyBufferLookup
  *
  *	Lookup a page request in the cache directory. A buffer is only
- *	returned for a T1 or T2 cache hit. B1 and B2 hits are just
+ *	returned for a T1 or T2 cache hit. B1 hits are just
  *	remembered here, to possibly affect the behaviour later.
  *
  *	recheck indicates we are rechecking after I/O wait; do not change
@@ -296,55 +342,10 @@ StrategyBufferLookup(BufferTag *tagPtr, bool recheck,
 	}
 
 	/*
-	 * In the case of a recheck we don't care about B1 or B2 hits here.
-	 * The bufmgr does this call only to make sure no-one faulted in the
-	 * block while we where busy flushing another; we don't want to doubly
-	 * adjust the T1target.
-	 *
-	 * Now for this really to end up as a B1 or B2 cache hit, we must have
-	 * been flushing for quite some time as the block not only must have
-	 * been read, but also traveled through the queue and evicted from the
-	 * T cache again already.
-	 *
-	 * VACUUM re-reads shouldn't adjust the target either.
-	 */
-	if (recheck || strategy_hint_vacuum)
-		return NULL;
-
-	/*
-	 * Adjust the target size of the T1 cache depending on if this is a B1
-	 * or B2 hit.
-	 */
-	switch (cdb->list)
-	{
-		case STRAT_LIST_B1:
-
-			/*
-			 * B1 hit means that the T1 cache is probably too small.
-			 * Adjust the T1 target size and continue below.
-			 */
-			T1_TARGET = Min(T1_TARGET + Max(B2_LENGTH / B1_LENGTH, 1),
-							NBuffers);
-			break;
-
-		case STRAT_LIST_B2:
-
-			/*
-			 * B2 hit means that the T2 cache is probably too small.
-			 * Adjust the T1 target size and continue below.
-			 */
-			T1_TARGET = Max(T1_TARGET - Max(B1_LENGTH / B2_LENGTH, 1), 0);
-			break;
-
-		default:
-			elog(ERROR, "buffer hash table corrupted: CDB->list = %d",
-				 cdb->list);
-	}
-
-	/*
 	 * Even though we had seen the block in the past, its data is not
 	 * currently in memory ... cache miss to the bufmgr.
 	 */
+	Assert(cdb->list == STRAT_LIST_B1);
 	return NULL;
 }
 
@@ -373,7 +374,7 @@ StrategyGetBuffer(int *cdb_replace_index)
 		 * We don't have a free buffer, must take one from T1 or T2.
 		 * Choose based on trying to converge T1len to T1target.
 		 */
-		if (T1_LENGTH >= Max(1, T1_TARGET))
+		if (T1_LENGTH >= T1_TARGET)
 		{
 			/*
 			 * We should take the first unpinned buffer from T1.
@@ -503,7 +504,7 @@ StrategyReplaceBuffer(BufferDesc *buf, BufferTag *newTag,
 
 	if (cdb_found_index >= 0)
 	{
-		/* This must have been a ghost buffer cache hit (B1 or B2) */
+		/* This must have been a ghost buffer cache hit (B1 list) */
 		cdb_found = &StrategyCDB[cdb_found_index];
 
 		/* Assert that the buffer remembered in cdb_found is the one */
@@ -523,14 +524,14 @@ StrategyReplaceBuffer(BufferDesc *buf, BufferTag *newTag,
 			Assert(BUFFERTAGS_EQUAL(cdb_replace->buf_tag, buf->tag));
 
 			/*
-			 * Under normal circumstances we move the evicted T list entry
-			 * to the corresponding B list.  However, T1 entries that
-			 * exist only because of VACUUM are just thrown into the
-			 * unused list instead. We don't expect them to be touched
-			 * again by the VACUUM, and if we put them into B1 then VACUUM
-			 * would skew T1_target adjusting.
+			 * Under normal circumstances we move evicted T1 list entries
+			 * to the B1 list.  However, T1 entries that exist only because
+			 * of VACUUM are just thrown into the unused list instead,
+			 * since it's unlikely they'll be touched again soon.  Similarly,
+			 * evicted T2 entries are thrown away; the LRU T2 entry cannot
+			 * have been touched recently.
 			 */
-			if (cdb_replace->t1_vacuum)
+			if (cdb_replace->t1_vacuum || cdb_replace->list == STRAT_LIST_T2)
 			{
 				BufTableDelete(&(cdb_replace->buf_tag));
 				STRAT_LIST_REMOVE(cdb_replace);
@@ -539,16 +540,8 @@ StrategyReplaceBuffer(BufferDesc *buf, BufferTag *newTag,
 			}
 			else
 			{
-				if (cdb_replace->list == STRAT_LIST_T1)
-				{
-					STRAT_LIST_REMOVE(cdb_replace);
-					STRAT_MRU_INSERT(cdb_replace, STRAT_LIST_B1);
-				}
-				else
-				{
-					STRAT_LIST_REMOVE(cdb_replace);
-					STRAT_MRU_INSERT(cdb_replace, STRAT_LIST_B2);
-				}
+				STRAT_LIST_REMOVE(cdb_replace);
+				STRAT_MRU_INSERT(cdb_replace, STRAT_LIST_B1);
 			}
 			/* And clear its block reference */
 			cdb_replace->buf_id = -1;
@@ -558,7 +551,7 @@ StrategyReplaceBuffer(BufferDesc *buf, BufferTag *newTag,
 			/* We are satisfying it with an unused buffer */
 		}
 
-		/* Now the found B CDB gets the buffer and is moved to T2 */
+		/* Now the found B1 CDB gets the buffer and is moved to T2 */
 		cdb_found->buf_id = buf->buf_id;
 		STRAT_LIST_REMOVE(cdb_found);
 		STRAT_MRU_INSERT(cdb_found, STRAT_LIST_T2);
@@ -567,37 +560,23 @@ StrategyReplaceBuffer(BufferDesc *buf, BufferTag *newTag,
 	{
 		/*
 		 * This was a complete cache miss, so we need to create a new CDB.
-		 * The goal is to keep T1len+B1len <= c.
+		 * We use a free one if available, else reclaim the tail end of B1.
 		 */
-		if (B1_LENGTH > 0 && (T1_LENGTH + B1_LENGTH) >= NBuffers)
+		if (StrategyControl->listUnusedCDB >= 0)
+		{
+			cdb_found = &StrategyCDB[StrategyControl->listUnusedCDB];
+			StrategyControl->listUnusedCDB = cdb_found->next;
+		}
+		else
 		{
-			/* So if B1 isn't empty and T1len+B1len >= c we take B1-LRU */
+			/* Can't fail because we have more CDBs than buffers... */
+			if (B1_LENGTH == 0)
+				elog(PANIC, "StrategyReplaceBuffer: out of CDBs");
 			cdb_found = &StrategyCDB[StrategyControl->listHead[STRAT_LIST_B1]];
 
 			BufTableDelete(&(cdb_found->buf_tag));
 			STRAT_LIST_REMOVE(cdb_found);
 		}
-		else
-		{
-			/* Otherwise, we try to use a free one */
-			if (StrategyControl->listUnusedCDB >= 0)
-			{
-				cdb_found = &StrategyCDB[StrategyControl->listUnusedCDB];
-				StrategyControl->listUnusedCDB = cdb_found->next;
-			}
-			else
-			{
-				/* If there isn't, we take B2-LRU ... except if */
-				/* T1len+B1len+T2len = c ... oh my */
-				if (B2_LENGTH > 0)
-					cdb_found = &StrategyCDB[StrategyControl->listHead[STRAT_LIST_B2]];
-				else
-					cdb_found = &StrategyCDB[StrategyControl->listHead[STRAT_LIST_B1]];
-
-				BufTableDelete(&(cdb_found->buf_tag));
-				STRAT_LIST_REMOVE(cdb_found);
-			}
-		}
 
 		/* Set the CDB's buf_tag and insert it into the hash table */
 		cdb_found->buf_tag = *newTag;
@@ -607,7 +586,7 @@ StrategyReplaceBuffer(BufferDesc *buf, BufferTag *newTag,
 		{
 			/*
 			 * The buffer was formerly in a T list, move its CDB to the
-			 * corresponding B list
+			 * appropriate list: B1 if T1, else discard it, as above
 			 */
 			cdb_replace = &StrategyCDB[cdb_replace_index];
 
@@ -623,8 +602,10 @@ StrategyReplaceBuffer(BufferDesc *buf, BufferTag *newTag,
 			}
 			else
 			{
+				BufTableDelete(&(cdb_replace->buf_tag));
 				STRAT_LIST_REMOVE(cdb_replace);
-				STRAT_MRU_INSERT(cdb_replace, STRAT_LIST_B2);
+				cdb_replace->next = StrategyControl->listUnusedCDB;
+				StrategyControl->listUnusedCDB = cdb_replace_index;
 			}
 			/* And clear its block reference */
 			cdb_replace->buf_id = -1;
@@ -694,7 +675,7 @@ StrategyInvalidateBuffer(BufferDesc *buf)
 	cdb = &StrategyCDB[cdb_id];
 
 	/*
-	 * Remove the CDB from the hashtable and the ARC queue it is currently
+	 * Remove the CDB from the hashtable and the queue it is currently
 	 * on.
 	 */
 	BufTableDelete(&(cdb->buf_tag));
@@ -758,7 +739,7 @@ StrategyDirtyBufferList(BufferDesc **buffers, BufferTag *buftags,
 
 	/*
 	 * Traverse the T1 and T2 list LRU to MRU in "parallel" and add all
-	 * dirty buffers found in that order to the list. The ARC strategy
+	 * dirty buffers found in that order to the list. The 2Q strategy
 	 * keeps all used buffers including pinned ones in the T1 or T2 list.
 	 * So we cannot miss any dirty buffers.
 	 */
@@ -813,6 +794,30 @@ StrategyDirtyBufferList(BufferDesc **buffers, BufferTag *buftags,
 
 
 /*
+ * StrategyShmemSize
+ *
+ * estimate the size of shared memory used by the freelist-related structures.
+ */
+int
+StrategyShmemSize(void)
+{
+	/* A1out list can hold 50% of NBuffers, per Johnson and Shasha */
+	int			nCDBs = NBuffers + NBuffers / 2;
+	int			size = 0;
+
+	/* size of CDB lookup hash table */
+	size += BufTableShmemSize(nCDBs);
+
+	/* size of the shared replacement strategy control block */
+	size += MAXALIGN(sizeof(BufferStrategyControl));
+
+	/* size of the CDB directory */
+	size += MAXALIGN(nCDBs * sizeof(BufferStrategyCDB));
+
+	return size;
+}
+
+/*
  * StrategyInitialize -- initialize the buffer cache replacement
  *		strategy.
  *
@@ -822,13 +827,15 @@ StrategyDirtyBufferList(BufferDesc **buffers, BufferTag *buftags,
 void
 StrategyInitialize(bool init)
 {
+	/* A1out list can hold 50% of NBuffers, per Johnson and Shasha */
+	int			nCDBs = NBuffers + NBuffers / 2;
 	bool		found;
 	int			i;
 
 	/*
 	 * Initialize the shared CDB lookup hashtable
 	 */
-	InitBufTable(NBuffers * 2);
+	InitBufTable(nCDBs);
 
 	/*
 	 * Get or create the shared strategy control block and the CDB's
@@ -836,7 +843,7 @@ StrategyInitialize(bool init)
 	StrategyControl = (BufferStrategyControl *)
 		ShmemInitStruct("Buffer Strategy Status",
 						sizeof(BufferStrategyControl) +
-						sizeof(BufferStrategyCDB) * (NBuffers * 2 - 1),
+						sizeof(BufferStrategyCDB) * (nCDBs - 1),
 						&found);
 	StrategyCDB = &(StrategyControl->cdb[0]);
 
@@ -854,13 +861,13 @@ StrategyInitialize(bool init)
 		StrategyControl->listFreeBuffers = 0;
 
 		/*
-		 * We start off with a target T1 list size of half the available
-		 * cache blocks.
+		 * We set the target T1 size to 1/4th of available buffers.
+		 * Possibly this should be a runtime tunable.
 		 */
-		StrategyControl->target_T1_size = NBuffers / 2;
+		StrategyControl->target_T1_size = NBuffers / 4;
 
 		/*
-		 * Initialize B1, T1, T2 and B2 lists to be empty
+		 * Initialize all lists to be empty
 		 */
 		for (i = 0; i < STRAT_NUM_LISTS; i++)
 		{
@@ -875,14 +882,14 @@ StrategyInitialize(bool init)
 		/*
 		 * All CDB's are linked as the listUnusedCDB
 		 */
-		for (i = 0; i < NBuffers * 2; i++)
+		for (i = 0; i < nCDBs; i++)
 		{
 			StrategyCDB[i].next = i + 1;
 			StrategyCDB[i].list = STRAT_LIST_UNUSED;
 			CLEAR_BUFFERTAG(StrategyCDB[i].buf_tag);
 			StrategyCDB[i].buf_id = -1;
 		}
-		StrategyCDB[NBuffers * 2 - 1].next = -1;
+		StrategyCDB[nCDBs - 1].next = -1;
 		StrategyControl->listUnusedCDB = 0;
 	}
 	else
diff --git a/src/backend/storage/buffer/localbuf.c b/src/backend/storage/buffer/localbuf.c
index b466f09..7d44cae 100644
--- a/src/backend/storage/buffer/localbuf.c
+++ b/src/backend/storage/buffer/localbuf.c
@@ -241,3 +241,17 @@ AtEOXact_LocalBuffers(bool isCommit)
 	}
 #endif
 }
+
+/*
+ * AtProcExit_LocalBuffers - ensure we have dropped pins during backend exit.
+ *
+ * This is just like AtProcExit_Buffers, but for local buffers.  We have
+ * to drop pins to ensure that any attempt to drop temp files doesn't
+ * fail in DropRelFileNodeBuffers.
+ */
+void
+AtProcExit_LocalBuffers(void)
+{
+	/* just zero the refcounts ... */
+	MemSet(LocalRefCount, 0, NLocBuffer * sizeof(*LocalRefCount));
+}
diff --git a/src/backend/tcop/utility.c b/src/backend/tcop/utility.c
index ea73b5c..abf1828 100644
--- a/src/backend/tcop/utility.c
+++ b/src/backend/tcop/utility.c
@@ -803,6 +803,10 @@ ProcessUtility(Node *parsetree,
 			{
 				LoadStmt   *stmt = (LoadStmt *) parsetree;
 
+				if (!superuser())
+					ereport(ERROR,
+							(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+							 errmsg("must be superuser to do LOAD")));
 				closeAllVfds(); /* probably not necessary... */
 				load_file(stmt->filename);
 			}
diff --git a/src/backend/utils/adt/inet_net_ntop.c b/src/backend/utils/adt/inet_net_ntop.c
index 54f4306..5fe0b24 100644
--- a/src/backend/utils/adt/inet_net_ntop.c
+++ b/src/backend/utils/adt/inet_net_ntop.c
@@ -1,33 +1,37 @@
 /*
- * Copyright (c) 1996 by Internet Software Consortium.
+ * Copyright (c) 2004 by Internet Systems Consortium, Inc. ("ISC")
+ * Copyright (c) 1996,1999 by Internet Software Consortium.
  *
  * Permission to use, copy, modify, and distribute this software for any
  * purpose with or without fee is hereby granted, provided that the above
  * copyright notice and this permission notice appear in all copies.
  *
- * THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM DISCLAIMS
- * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL INTERNET SOFTWARE
- * CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
- * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
- * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
- * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
- * SOFTWARE.
+ * THE SOFTWARE IS PROVIDED "AS IS" AND ISC DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL ISC BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
+ * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  *
  *	  $PostgreSQL$
  */
 
+#if defined(LIBC_SCCS) && !defined(lint)
+static const char rcsid[] = "Id: inet_net_ntop.c,v 1.1.2.2 2004/03/09 09:17:27 marka Exp $";
+#endif
+
 #include "postgres.h"
 
+#include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
 
-#include <errno.h>
-
 #include "utils/inet.h"
 #include "utils/builtins.h"
 
+
 #define NS_IN6ADDRSZ 16
 #define NS_INT16SZ 2
 
@@ -81,7 +85,7 @@ inet_cidr_ntop(int af, const void *src, int bits, char *dst, size_t size)
  *	pointer to dst, or NULL if an error occurred (check errno).
  * note:
  *	network byte order assumed.  this means 192.5.5.240/28 has
- *	0x11110000 in its fourth octet.
+ *	0b11110000 in its fourth octet.
  * author:
  *	Paul Vixie (ISC), July 1996
  */
@@ -98,23 +102,28 @@ inet_cidr_ntop_ipv4(const u_char *src, int bits, char *dst, size_t size)
 		errno = EINVAL;
 		return (NULL);
 	}
+
 	if (bits == 0)
 	{
 		if (size < sizeof "0")
 			goto emsgsize;
 		*dst++ = '0';
+		size--;
 		*dst = '\0';
 	}
 
 	/* Format whole octets. */
 	for (b = bits / 8; b > 0; b--)
 	{
-		if (size < sizeof ".255")
+		if (size <= sizeof "255.")
 			goto emsgsize;
 		t = dst;
-		if (dst != odst)
-			*dst++ = '.';
 		dst += SPRINTF((dst, "%u", *src++));
+		if (b > 1)
+		{
+			*dst++ = '.';
+			*dst = '\0';
+		}
 		size -= (size_t) (dst - t);
 	}
 
@@ -122,7 +131,7 @@ inet_cidr_ntop_ipv4(const u_char *src, int bits, char *dst, size_t size)
 	b = bits % 8;
 	if (b > 0)
 	{
-		if (size < sizeof ".255")
+		if (size <= sizeof ".255")
 			goto emsgsize;
 		t = dst;
 		if (dst != odst)
@@ -133,10 +142,9 @@ inet_cidr_ntop_ipv4(const u_char *src, int bits, char *dst, size_t size)
 	}
 
 	/* Format CIDR /width. */
-	if (size < sizeof "/32")
+	if (size <= sizeof "/32")
 		goto emsgsize;
 	dst += SPRINTF((dst, "/%u", bits));
-
 	return (odst);
 
 emsgsize:
@@ -146,7 +154,7 @@ emsgsize:
 
 /*
  * static char *
- * inet_net_ntop_ipv6(src, bits, fakebits, dst, size)
+ * inet_cidr_ntop_ipv6(src, bits, fakebits, dst, size)
  *	convert IPv6 network number from network to presentation format.
  *	generates CIDR style result always. Picks the shortest representation
  *	unless the IP is really IPv4.
@@ -173,7 +181,6 @@ inet_cidr_ntop_ipv6(const u_char *src, int bits, char *dst, size_t size)
 				tmp_zero_l;
 	int			i;
 	int			is_ipv4 = 0;
-	int			double_colon = 0;
 	unsigned char inbuf[16];
 	char		outbuf[sizeof("xxxx:xxxx:xxxx:xxxx:xxxx:xxxx:255.255.255.255/128")];
 	char	   *cp;
@@ -187,14 +194,12 @@ inet_cidr_ntop_ipv6(const u_char *src, int bits, char *dst, size_t size)
 	}
 
 	cp = outbuf;
-	double_colon = 0;
 
 	if (bits == 0)
 	{
 		*cp++ = ':';
 		*cp++ = ':';
 		*cp = '\0';
-		double_colon = 1;
 	}
 	else
 	{
@@ -244,8 +249,8 @@ inet_cidr_ntop_ipv6(const u_char *src, int bits, char *dst, size_t size)
 		}
 
 		if (zero_l != words && zero_s == 0 && ((zero_l == 6) ||
-					  ((zero_l == 5 && s[10] == 0xff && s[11] == 0xff) ||
-					   ((zero_l == 7 && s[14] != 0 && s[15] != 1)))))
+						  ((zero_l == 5 && s[10] == 0xff && s[11] == 0xff) ||
+						   ((zero_l == 7 && s[14] != 0 && s[15] != 1)))))
 			is_ipv4 = 1;
 
 		/* Format whole words. */
@@ -257,10 +262,7 @@ inet_cidr_ntop_ipv6(const u_char *src, int bits, char *dst, size_t size)
 				if (p == zero_s)
 					*cp++ = ':';
 				if (p == words - 1)
-				{
 					*cp++ = ':';
-					double_colon = 1;
-				}
 				s++;
 				s++;
 				continue;
@@ -286,18 +288,8 @@ inet_cidr_ntop_ipv6(const u_char *src, int bits, char *dst, size_t size)
 			}
 		}
 	}
-
-	if (!double_colon)
-	{
-		if (bits < 128 - 32)
-			cp += SPRINTF((cp, "::"));
-		else if (bits < 128 - 16)
-			cp += SPRINTF((cp, ":0"));
-	}
-
 	/* Format CIDR /width. */
 	SPRINTF((cp, "/%u", bits));
-
 	if (strlen(outbuf) + 1 > size)
 		goto emsgsize;
 	strcpy(dst, outbuf);
@@ -309,6 +301,7 @@ emsgsize:
 	return (NULL);
 }
 
+
 /*
  * char *
  * inet_net_ntop(af, src, bits, dst, size)
@@ -368,7 +361,7 @@ inet_net_ntop_ipv4(const u_char *src, int bits, char *dst, size_t size)
 	/* Always format all four octets, regardless of mask length. */
 	for (b = len; b > 0; b--)
 	{
-		if (size < sizeof ".255")
+		if (size <= sizeof ".255")
 			goto emsgsize;
 		t = dst;
 		if (dst != odst)
@@ -380,7 +373,7 @@ inet_net_ntop_ipv4(const u_char *src, int bits, char *dst, size_t size)
 	/* don't print masklen if 32 bits */
 	if (bits != 32)
 	{
-		if (size < sizeof "/32")
+		if (size <= sizeof "/32")
 			goto emsgsize;
 		dst += SPRINTF((dst, "/%u", bits));
 	}
@@ -401,7 +394,7 @@ decoct(const u_char *src, int bytes, char *dst, size_t size)
 
 	for (b = 1; b <= bytes; b++)
 	{
-		if (size < sizeof "255.")
+		if (size <= sizeof "255.")
 			return (0);
 		t = dst;
 		dst += SPRINTF((dst, "%u", *src++));
diff --git a/src/backend/utils/adt/inet_net_pton.c b/src/backend/utils/adt/inet_net_pton.c
index 2967df9..5e97a8c 100644
--- a/src/backend/utils/adt/inet_net_pton.c
+++ b/src/backend/utils/adt/inet_net_pton.c
@@ -1,43 +1,47 @@
 /*
- * Copyright (c) 1996 by Internet Software Consortium.
+ * Copyright (c) 2004 by Internet Systems Consortium, Inc. ("ISC")
+ * Copyright (c) 1996,1999 by Internet Software Consortium.
  *
  * Permission to use, copy, modify, and distribute this software for any
  * purpose with or without fee is hereby granted, provided that the above
  * copyright notice and this permission notice appear in all copies.
  *
- * THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM DISCLAIMS
- * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL INTERNET SOFTWARE
- * CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
- * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
- * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
- * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
- * SOFTWARE.
+ * THE SOFTWARE IS PROVIDED "AS IS" AND ISC DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL ISC BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
+ * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  *
  *	  $PostgreSQL$
  */
 
+#if defined(LIBC_SCCS) && !defined(lint)
+static const char rcsid[] = "Id: inet_net_pton.c,v 1.4.2.3 2004/03/17 00:40:11 marka Exp $";
+#endif
+
 #include "postgres.h"
 
+#include <sys/types.h>
 #include <sys/socket.h>
 #include <netinet/in.h>
 #include <arpa/inet.h>
-
 #include <assert.h>
 #include <ctype.h>
-#include <errno.h>
 
 #include "utils/inet.h"
-
 #include "utils/builtins.h"
 
+
 static int	inet_net_pton_ipv4(const char *src, u_char *dst);
 static int	inet_cidr_pton_ipv4(const char *src, u_char *dst, size_t size);
 static int	inet_net_pton_ipv6(const char *src, u_char *dst);
 static int	inet_cidr_pton_ipv6(const char *src, u_char *dst, size_t size);
 
+
 /*
- * static int
+ * int
  * inet_net_pton(af, src, dst, size)
  *	convert network number from presentation to network format.
  *	accepts hex octets, hex strings, decimal octets, and /CIDR.
@@ -85,19 +89,18 @@ inet_net_pton(int af, const char *src, void *dst, size_t size)
  *	not an IPv4 network specification.
  * note:
  *	network byte order assumed.  this means 192.5.5.240/28 has
- *	0x11110000 in its fourth octet.
+ *	0b11110000 in its fourth octet.
  * author:
  *	Paul Vixie (ISC), June 1996
  */
 static int
 inet_cidr_pton_ipv4(const char *src, u_char *dst, size_t size)
 {
-	static const char
-				xdigits[] = "0123456789abcdef",
-				digits[] = "0123456789";
+	static const char xdigits[] = "0123456789abcdef";
+	static const char digits[] = "0123456789";
 	int			n,
 				ch,
-				tmp,
+				tmp = 0,
 				dirty,
 				bits;
 	const u_char *odst = dst;
@@ -107,10 +110,9 @@ inet_cidr_pton_ipv4(const char *src, u_char *dst, size_t size)
 		&& isxdigit((unsigned char) src[1]))
 	{
 		/* Hexadecimal: Eat nybble string. */
-		if (size <= 0)
+		if (size <= 0U)
 			goto emsgsize;
 		dirty = 0;
-		tmp = 0;
 		src++;					/* skip x or X. */
 		while ((ch = *src++) != '\0' && isxdigit((unsigned char) ch))
 		{
@@ -124,7 +126,7 @@ inet_cidr_pton_ipv4(const char *src, u_char *dst, size_t size)
 				tmp = (tmp << 4) | n;
 			if (++dirty == 2)
 			{
-				if (size-- <= 0)
+				if (size-- <= 0U)
 					goto emsgsize;
 				*dst++ = (u_char) tmp;
 				dirty = 0;
@@ -132,7 +134,7 @@ inet_cidr_pton_ipv4(const char *src, u_char *dst, size_t size)
 		}
 		if (dirty)
 		{						/* Odd trailing nybble? */
-			if (size-- <= 0)
+			if (size-- <= 0U)
 				goto emsgsize;
 			*dst++ = (u_char) (tmp << 4);
 		}
@@ -153,7 +155,7 @@ inet_cidr_pton_ipv4(const char *src, u_char *dst, size_t size)
 					goto enoent;
 			} while ((ch = *src++) != '\0' &&
 					 isdigit((unsigned char) ch));
-			if (size-- <= 0)
+			if (size-- <= 0U)
 				goto emsgsize;
 			*dst++ = (u_char) tmp;
 			if (ch == '\0' || ch == '/')
@@ -200,22 +202,28 @@ inet_cidr_pton_ipv4(const char *src, u_char *dst, size_t size)
 		if (*odst >= 240)		/* Class E */
 			bits = 32;
 		else if (*odst >= 224)	/* Class D */
-			bits = 4;
+			bits = 8;
 		else if (*odst >= 192)	/* Class C */
 			bits = 24;
 		else if (*odst >= 128)	/* Class B */
 			bits = 16;
-		else
-			/* Class A */
+		else					/* Class A */
 			bits = 8;
 		/* If imputed mask is narrower than specified octets, widen. */
-		if (bits >= 8 && bits < ((dst - odst) * 8))
+		if (bits < ((dst - odst) * 8))
 			bits = (dst - odst) * 8;
+
+		/*
+		 * If there are no additional bits specified for a class D address
+		 * adjust bits to 4.
+		 */
+		if (bits == 8 && *odst == 224)
+			bits = 4;
 	}
 	/* Extend network to cover the actual mask. */
 	while (bits > ((dst - odst) * 8))
 	{
-		if (size-- <= 0)
+		if (size-- <= 0U)
 			goto emsgsize;
 		*dst++ = '\0';
 	}
diff --git a/src/backend/utils/adt/nabstime.c b/src/backend/utils/adt/nabstime.c
index 8d6cf20..ea79b67 100644
--- a/src/backend/utils/adt/nabstime.c
+++ b/src/backend/utils/adt/nabstime.c
@@ -306,15 +306,13 @@ abstimein(PG_FUNCTION_ARGS)
 			   *tm = &date;
 	int			dterr;
 	char	   *field[MAXDATEFIELDS];
-	char		lowstr[MAXDATELEN + 1];
+	char		workbuf[MAXDATELEN + 1];
 	int			dtype;
 	int			nf,
 				ftype[MAXDATEFIELDS];
 
-	if (strlen(str) >= sizeof(lowstr))
-		dterr = DTERR_BAD_FORMAT;
-	else
-		dterr = ParseDateTime(str, lowstr, field, ftype, MAXDATEFIELDS, &nf);
+	dterr = ParseDateTime(str, workbuf, sizeof(workbuf),
+						  field, ftype, MAXDATEFIELDS, &nf);
 	if (dterr == 0)
 		dterr = DecodeDateTime(field, ftype, nf, &dtype, tm, &fsec, &tz);
 	if (dterr != 0)
@@ -711,12 +709,10 @@ reltimein(PG_FUNCTION_ARGS)
 	char	   *field[MAXDATEFIELDS];
 	int			nf,
 				ftype[MAXDATEFIELDS];
-	char		lowstr[MAXDATELEN + 1];
+	char		workbuf[MAXDATELEN + 1];
 
-	if (strlen(str) >= sizeof(lowstr))
-		dterr = DTERR_BAD_FORMAT;
-	else
-		dterr = ParseDateTime(str, lowstr, field, ftype, MAXDATEFIELDS, &nf);
+	dterr = ParseDateTime(str, workbuf, sizeof(workbuf),
+						  field, ftype, MAXDATEFIELDS, &nf);
 	if (dterr == 0)
 		dterr = DecodeInterval(field, ftype, nf, &dtype, tm, &fsec);
 	if (dterr != 0)
